org	00h

;89S52 a 93C46 eeprom
;popis portu,
;segment A P2.5			4
;segment B P2.4			5
;segment C P2.3			6
;segment D P2.2			7
;segment E P2.1			9
;segment F P2.0			10
;segment G P3.7			11
;
;segment jednotky P1.1		25
;segment desitky  P1.0		26
;segment S-metru  P0.2		33
;
;vystupy
;BEEP	P2.7			1
;AM-FM	P2.6			2
;
;vstupy
;option	 P3.6			 12
;SCAN	 P3.5			 13
;CH UP	 P3.4 a	P3.3 proti GND	 14,15
;CH DOWN P3.3 proti GND		 15
;PTT	P3.2			 16
;AM-FM vstup P1.3 proti	P3.4	 22
;proti option	P1.4		 23
;RSSI signal z MeFky P1.2	24
;
;komunikace do PLL
;CLK P0.0			 30
;DI  P0.1			 31
;enable	P0.3			 32
;
;
;pripojeni EEPROM
;
;CS    P0.4
;DO    P0.5
;DI    P0.6
;CLK   P0.7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	p0,#11110100b
	mov	p1,#11111111b
	mov	p2,#11111111b
	mov	p3,#11111111b
	mov	20,#1	;cislo kanalu1
	mov	21,#0	;cislo kanalu2
	mov	24,#0	;UP
	mov	25,#0	;DOWN
	mov	26,#0	;scan up - down
	mov	27,#20	 ;scan cas
	mov	28,#5	 ;scan cas
	mov	29,#1	;0- nic, 1-RX,2-TX
	mov	30,#1	; set PTT
	mov	31,#5	; spozdeji TX TR
	mov	32,#0	; scan,	0 neskenuje, 1 skenuje
	mov	33,#20	; spozdeni FM/AM placitka
	mov	34,#0	;DETEKCE FMFM tlacitka
	mov	35,#0	;navoleni scan
	mov	36,#0	;navoleni DW
	mov	37,#0	;navoleni odskok kanalu RX,TX
	mov	38,#255	;voleni funkci
	mov	39,#0	;citac vyberu nastavovane funkce
	mov	40,#0	; cilo nastaveneho kanalu 8bit
	mov	41,#0		; nasnaveni poctu odesilanych dat do PLL
	mov	42,#0	; zapamatovani predchoziho kanalu



;;;;;;;;;;;;;;;;;;;;;;;;;;tabulka kanalu;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	48,#91	;hodnoty pro prijem, pro vysilani konstanta +45
	mov	49,#92
	mov	50,#93
	mov	51,#95
	mov	52,#96
	mov	53,#97
	mov	54,#98
	mov	55,#100
	mov	56,#101
	mov	57,#102
	mov	58,#103
	mov	59,#105
	mov	60,#106
	mov	61,#107
	mov	62,#108
	mov	63,#110
	mov	64,#111
	mov	65,#112
	mov	66,#113
	mov	67,#115
	mov	68,#116
	mov	69,#117
	mov	70,#120
	mov	71,#118
	mov	72,#119
	mov	73,#121
	mov	74,#122
	mov	75,#123
	mov	76,#124
	mov	77,#125
	mov	78,#126
	mov	79,#127
	mov	80,#128
	mov	81,#129
	mov	82,#130
	mov	83,#131
	mov	84,#132
	mov	85,#133
	mov	86,#134
	mov	87,#135
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;konec 40CH CB pasmo C;;;;;;;;;;;;;;;;;;;;;;;;
	mov	88,#46
	mov	89,#47
	mov	90,#48
	mov	91,#50
	mov	92,#51
	mov	93,#52
	mov	94,#53
	mov	95,#55
	mov	96,#56
	mov	97,#57
	mov	98,#58
	mov	99,#60
	mov	100,#61
	mov	101,#62
	mov	102,#63
	mov	103,#65
	mov	104,#66
	mov	105,#67
	mov	106,#68
	mov	107,#70
	mov	108,#71
	mov	109,#72
	mov	110,#75
	mov	111,#73
	mov	112,#74
	mov	113,#76
	mov	114,#77
	mov	115,#78
	mov	116,#79
	mov	117,#80
	mov	118,#81
	mov	119,#82
	mov	120,#83
	mov	121,#84
	mov	122,#85
	mov	123,#86
	mov	124,#87
	mov	125,#88
	mov	126,#89
	mov	127,#90
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;konec tabulky 80 kamalu CB;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	jmp	start
;;;;;;;;;;;;;;;;;;;;;;; nastaveni PLL PCM1;;;;;;;;;;;;;;
PMC1:	mov	a,29
	jnz	sk26
	ret
sk26:	dec	a
	jnz	sk40
	mov	a,#10001100b	;00100001b
	jmp	sk41
sk40:	mov	a,#10001010b	;01000001b
sk41:	mov	41,#8
	setb	p0.3
	rlc	a
	mov	p0.1,c
	clr	c
	call	CLK1
	djnz	41,$-7
	clr	p0.1
	clr	p0.3
	mov	29,#0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
prelad:
	mov	a,40
	cjne	a,42,sk42
	ret
sk42:	mov	42,40	
	mov	29,#1
	setb	p0.3
	mov	41,#8
	mov	a,#00111000b
	rlc	a
	mov	p0.1,c
	clr	c
	call	CLK1
	djnz	41,$-7
	mov	41,#8
	mov	a,#00000000b
	rlc	a
	mov	p0.1,c
	clr	c
	call	CLK1
	djnz	41,$-7
	mov	41,#8
	mov	a,#01000000b
	rlc	a
	mov	p0.1,c
	clr	c
	call	CLK1
	djnz	41,$-7
	mov	41,#8
	mov	a,#00000000b
	rlc	a
	mov	p0.1,c
	clr	c
	call	CLK1
	djnz	41,$-7
	clr	P0.1
	clr	p0.3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Z - pevna hodnota TX;;;;;;;;;;;;;;;
	mov	41,#7
	mov	a,#00010100b
	rlc	a
	mov	p0.1,c
	clr	c
	call	CLK1
	djnz	41,$-7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;K - pevna hodnota TX;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	a,#47
	add	a,40
	mov	r0,a
	mov	a,@r0
	add	a,#45
	mov	41,#8
	rlc	a
	mov	p0.1,c
	clr	c
	call	CLK1
	djnz	41,$-7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	setb	p0.1	;nultej bit
	call	clk1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Z - pavna hodnota RX ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	41,#7
	mov	a,#00001100b
	rlc	a
	mov	p0.1,c
	clr	c
	call	CLK1
	djnz	41,$-7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;K - pevna hodnota RX ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	a,#47
	add	a,40
	mov	r0,a
	mov	a,@r0
	mov	41,#8
	rlc	a
	mov	p0.1,c
	clr	c
	call	CLK1
	djnz	41,$-7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	clr	P0.1	; nuptej bit
	call	CLK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	clr	p0.1
	setb	p0.3
	clr	p0.3
	ret
CLK1:	setb	P0.0
	clr	P0.0
	ret
;;;;;;;;;;;;;;;;;;;;; start programu;;;;;;;;;;;;;;;;;;;;;;;;;
start:
	call	PMC1	;PLL set, RX,TX
	call	prelad
	call	chan
	call	display
	call	fmam
	call	skenMF
	call	prepni
	call	sekveu
	call	sekved
	call	scan
	call	RTX
	jmp	start
;;;;;;;;;;;;;;;;;;;;;;;;;;konec programu;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;prevod kanalu do 8bit cisla, 1-80;;;;;;;;;;;;;;
chan:	mov	b,#10
	mov	a,21
	mul	AB
	add	a,20
	mov	40,a	; adresa 40, cislo kanalu
	jnz	ok
	mov	20,#00000001b
ok:	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;zobrazeni na LED display;;;;;;;;;;;;;;;;
display:call	seg1
	call	seg10
	ret
seg1:	mov	a,20
	jnz	sk1
	anl	p2,#11000000b	;0
	cpl	P1.1
	call	casl
	ret
sk1:	dec	a
	jnz	sk2
	anl	p2,#11100111b	;1
	cpl	P1.1
	call	casl
	ret
sk2:	dec	a
	jnz	sk3
	anl	P2,#11001001b	;2
	cpl	P3.7
	cpl	P1.1
	call	casl
	ret
sk3:	dec	a
	jnz	sk4
	anl	P2,#11000011b	;3
	cpl	P3.7
	cpl	P1.1
	call	casl
	ret
sk4:	dec	a
	jnz	sk5
	anl	P2,#11100110b	;4
	cpl	p3.7
	cpl	p1.1
	call	casl
	ret
sk5:	dec	a
	jnz	sk6
	anl	p2,#11010010b	;5
	cpl	P3.7
	cpl	P1.1
	call	casl
	ret
sk6:	dec	a
	jnz	sk7
	anl	p2,#11010000b	;6
	cpl	P3.7
	cpl	P1.1
	call	casl
	ret
sk7:	dec	a
	jnz	sk8
	anl	P2,#11000111b	;7
	cpl	P1.1
	call	casl
	ret
sk8:	dec	a
	jnz	sk9
	anl	P2,#11000000b	;8
	cpl	p3.7
	cpl	P1.1
	call	casl
	ret
sk9:	anl	P2,#11000010b	;9
	cpl	p3.7
	cpl	p1.1
	call	casl
	ret
seg10:	mov	a,21
	jnz	sk10
	anl	p2,#11111111b	;0
	cpl	P1.0
	call	casl
	ret
sk10:	dec	a
	jnz	sk11
	anl	p2,#11100111b	;1
	cpl	P1.0
	call	casl
	ret
sk11:	dec	a
	jnz	sk12
	anl	P2,#11001001b	;2
	cpl	P3.7
	cpl	P1.0
	call	casl
	ret
sk12:	dec	a
	jnz	sk13
	anl	P2,#11000011b	;3
	cpl	P3.7
	cpl	P1.0
	call	casl
	ret
sk13:	dec	a
	jnz	sk14
	anl	P2,#11100110b	;4
	cpl	p3.7
	cpl	p1.0
	call	casl
	ret
sk14:	dec	a
	jnz	sk15
	anl	p2,#11010010b	;5
	cpl	P3.7
	cpl	P1.0
	call	casl
	ret
sk15:	dec	a
	jnz	sk16
	anl	p2,#11010000b	;6
	cpl	P3.7
	cpl	P1.0
	call	casl
	ret
sk16:	dec	a
	jnz	sk17
	anl	P2,#11000111b	;7
	cpl	P1.0
	call	casl
	ret
sk17:	anl	P2,#11000000b	;8
	cpl	p3.7
	cpl	P1.0
	call	casl
	ret
casl:	mov	16,#00111111b
	djnz	16,$
	setb	P1.1
	setb	P1.0
	setb	p2.0
	setb	P2.1
	setb	P2.2
	setb	P2.3
	setb	P2.4
	setb	P2.5
	setb	P3.7
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



fmam:	clr	p1.3
	mov	a,P3
	anl	a,#00011100b
	xrl	a,#00001100b
	jnz	sk36
	mov	a,33
	jz	sk37
	dec	33
	setb	P1.3
	ret

sk37:	

	mov	a,39
	jnz	sk39
	mov	34,#1
	setb	P1.3
	mov	a,38
	jz	sk39
	dec	38
	ret
sk39:	mov	34,#0
	mov	39,#1
	cpl	p2.7
	setb	p1.3
	ret




sk36:	mov	a,39
	jz	sk43
	xrl	35,#00000001b
sk43:	mov	39,#0
	mov	a,34
	jz	sk38
	cpl	P2.6
	mov	34,#0
sk38:	mov	33,#20
	mov	38,#255
	setb	p1.3
	ret

skenMF:
	jnb	p1.2,sk44
	mov	32,35
	ret
	
sk44:
	mov	32,#0
	ret
	



;;;;;;;;;;;;;;;;;;;;;;;;;;prepinani kanalu ;;;;;;;;;;;
prepni:
      mov	a,P3
       anl	a,#00011000b
       xrl	a,#00011000b
       mov	23,a
       jnz	sk18
       mov	22,#3
       ret
sk18:	mov	a,22
	jnz	sk19
	ret
sk19:	dec	22
	mov	a,22
	jz	sk20
	ret
sk20:	mov	a,23
	anl	a,#00010000b
	jz	sk21
	mov	24,#1
	mov	26,#0
	ret
sk21:	mov	25,#1
	mov	26,#1
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;prepinani kanalu UP DOWN;;;;;;;;;;
sekveu:	mov	a,24
	jz	sk22
	mov	24,#0
	inc	20
	mov	a,21
	cjne	a,#8,sk23
	mov	a,20
	jz	sk23
	mov	20,#1
	mov	21,#0
	ret
	mov	20,#1
	mov	21,#0
	ret
sk23:	mov	a,20
	cjne	a,#10,sk22
	mov	20,#0
	inc	21
sk22:	ret
sekved:	mov	a,25
	jz	sk24
	mov	25,#0
	mov	a,20
	jz	sk25
	dec	20
	mov	a,20
	add	a,21
	jnz	sk24
	mov	21,#8
	mov	20,#0
	ret
sk25:	mov	20,#9
	dec	21
sk24:	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;skenovani, nahoru nebo dolu;;;;;;;;;;;;;;;;
scan:
	mov	a,32
	jz	sk27
	mov	a,27
	jz	sk33
	dec	27
	ret
sk33:	mov	27,#20
	mov	a,28
	jz	sk34
	dec	28
	ret
sk34:	mov	28,#5
	mov	a,26
	jz	sk35
	mov	25,#1
	ret
sk35:	mov	24,#1
sk27:	mov	27,#20
	mov	28,#5
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; prepina vysilani prijem;;;;;;;;;;;;
RTX:	jnb	P3.2,sk28
	mov	a,30
	jz	sk29
	mov	a,31
	jz	sk32
	dec	31
	ret
sk32:	mov	30,#0
	mov	31,#5
	mov	29,#1
	ret
sk28:	mov	a,30
	jnz	sk29
	mov	a,31
	jz	sk31
	dec	31
	ret
sk31:	mov	30,#1
	mov	31,#5
	mov	29,#2
sk29:	ret

END